<!DOCTYPE html>
<html>
  <head>
    <title>UDPipe GUI</title>
    <meta charset="utf-8">

    <script src="https://code.jquery.com/jquery-3.4.1.js" type="text/javascript"></script>
    <script src="js-treex-view.min.js" type="text/javascript"></script>

    <link rel="stylesheet" href="https://unpkg.com/material-components-web@5.1.0/dist/material-components-web.min.css">
    <link rel="stylesheet" href="https://fonts.googleapis.com/icon?family=Material+Icons">
    <link href="https://fonts.googleapis.com/css?family=Noto+Sans&display=swap" rel="stylesheet">
    <script src="https://unpkg.com/material-components-web@5.1.0/dist/material-components-web.min.js"></script>
  </head>

  <body>

    <div id="udpipe-input">
      <div class="mdc-text-field mdc-text-field--textarea mdc-text-field--fullwidth" data-mdc-auto-init="MDCTextField" style="margin-top: 10px">
        <textarea id="input" class="mdc-text-field__input" rows="5" cols="80"></textarea>
        <div class="mdc-notched-outline">
          <div class="mdc-notched-outline__leading"></div>
          <div class="mdc-notched-outline__notch"><label for="input" class="mdc-floating-label">Input Text</label></div>
          <div class="mdc-notched-outline__trailing"></div>
        </div>
      </div>
    </div>

    <button class="mdc-button mdc-button--raised" id="submit" data-mdc-auto-init="MDCRipple" style="margin-top: 10px; width: 100%" disabled>
      <i class="material-icons mdc-button__icon" aria-hidden="true">build</i><span class="mdc-button__label">Process Input</span>
    </button>

    <div role="progressbar" class="mdc-linear-progress" id="progress_bar" data-mdc-auto-init="MDCLinearProgress" style="margin-top: 10px; display: none">
      <div class="mdc-linear-progress__buffering-dots"></div>
      <div class="mdc-linear-progress__buffer"></div>
      <div class="mdc-linear-progress__bar mdc-linear-progress__primary-bar">
        <span class="mdc-linear-progress__bar-inner"></span>
      </div>
      <div class="mdc-linear-progress__bar mdc-linear-progress__secondary-bar">
        <span class="mdc-linear-progress__bar-inner"></span>
      </div>
    </div>

    <div id="output_tree" style="margin-top: 10px">
      <div id="output_tree_content"></div>
    </div>

<script type="text/javascript"><!--
  mdc.autoInit();
  progress_bar = document.getElementById("progress_bar").MDCLinearProgress;

  progress_bar.determinate = false;
  progress_bar.progress = 0;

  // fix up directionality, e.g. if this gui is being used for Arabic or Urdu
  // then the text entry field and the result sentence(s) should be rendered as RTL
  var myUrl = new URL(window.location.href);
  if(myUrl.searchParams.has("dir")) {
    jQuery("#udpipe-input").attr("dir", myUrl.searchParams.get("dir"));
    var dirCss = jQuery("<style></style>");
    dirCss.text("#output_tree_content div[sentence] { direction: " + myUrl.searchParams.get("dir") + "; }");
    dirCss.appendTo("head");
  }

  // Get config from ELG main frame
  var serviceUrl = null;
  var authHeader = null;
  var i18nUrl = null;
  window.addEventListener("message", function(e) {
    try {
      serviceInfo = JSON.parse(e.data);

      if (serviceInfo.ServiceUrl) {
        serviceUrl = serviceInfo.ServiceUrl;
        i18nUrl = new URL(serviceUrl.indexOf("async/") >= 0 ? "../../../i18n/resolve" : "../../i18n/resolve", serviceUrl);
        jQuery("#submit").prop("disabled", false);
      }
      if (serviceInfo.Authorization) {
        authHeader = serviceInfo.Authorization;
      }
      if (serviceInfo.StyleCss) {
        var link = jQuery('<link type="text/css" rel="stylesheet" media="screen,print">');
        link.attr("href", serviceInfo.StyleCss);
        jQuery("head").append(link);
      }
    }
    catch (err) {
    }
  });
  setTimeout(function() {
    window.parent.postMessage("GUI:Ready for config", window.location.origin);
  }, 500);

  function draw_trees(elg) {
    // Start by finding sentence ends
    var elg_sentences = elg.response.annotations["udpipe/sentences"], sentence_ends = {};
    for (var i in elg_sentences) {
      sentence_ends[elg_sentences[i].end] = "1";
    }

    // Process the tokens
    var elg_tokens = elg.response.annotations["udpipe/tokens"];
    var trees = [], tree_desc = [], tree_nodes = [];
    for (var i in elg_tokens) {
      var elg_token = elg_tokens[i];
      for (var j in elg_token.features.words) {
        var elg_word = elg_token.features.words[j];

        if (!tree_nodes.length) tree_nodes.push({id:'w0', ord:0, parent:null, data:{form:"<root>"}, labels:['<root>','','']});

        if (tree_desc.length) tree_desc.push([' ', 'space']);
        tree_desc.push([elg_word.form, 'w'+tree_nodes.length]);

        tree_nodes.push({id:'w'+tree_nodes.length, ord:tree_nodes.length, parent:"head" in elg_word?'w'+elg_word.head:null, data:{
          form:elg_word.form, lemma:elg_word.lemma || "", upostag:elg_word.upos || "", xpostag:elg_word.xpos || "",
          feats:elg_word.feats || "", head:"head" in elg_word ? elg_word.head : "", deprel:elg_word.deprel || "",
          token_start:elg_token.start, token_end:elg_token.end,
        }, labels:[elg_word.form, '#{#00008b}'+(elg_word.deprel || " "), '#{#004048}'+(elg_word.upos || " ")]});
      }

      if (elg_token.end in sentence_ends) {
        var last_child = [];
        for (var i = 1; i < tree_nodes.length; i++) {
          var head = tree_nodes[i].data.head;
          if (head !== "") {
            if (!last_child[head]) tree_nodes[head].firstson = 'w'+i;
            else tree_nodes[last_child[head]].rbrother = 'w'+i;
            last_child[head] = i;
          }
        }

        trees.push({desc:tree_desc,zones:{conllu:{trees:{"a":{layer:"a",nodes:tree_nodes}}}}});
        tree_desc = [];
        tree_nodes = [];
      }
    }

    jQuery('#output_tree_content').treexView(trees);
  }

  function reportErrors(errors) {
    function localResolve() {
      var message = "";
      for (var i in errors) {
        message += errors[i].text.replace(/{(\d+)}/g, function(match, num) { return errors[i].params[parseInt(num, 10)] }) + "\n";
      }
      alert(message);
    }

    // Try resolving with i18nUrl
    if (i18nUrl) {
      jQuery.ajax(i18nUrl.href, {data: JSON.stringify(errors), contentType: "application/json", dataType: "json", method: "POST", success: function(json) {
        alert(json);
      }, error: function(jqXHR, textStatus) {
        localResolve();
      }});
    } else {
      localResolve();
    }
  }

  jQuery("#submit").click(function() {
    jQuery('#output_tree_content').empty();

    var text = jQuery('#input').val();
    if (!text) return;

    jQuery('#submit>i').html('timelapse');
    jQuery.ajax(serviceUrl, {data: text, contentType: "text/plain", dataType: "json", method: "POST",
                xhrFields: {withCredentials: true}, headers: {Authorization: authHeader}, success: function(json) {
      if ("failure" in json) {
        jQuery('#submit>i').html('build');
        reportErrors(json.failure.errors);
      } else if ("response" in json && json.response.type == "stored") {
        jQuery("#progress_bar").show();
        progress_bar.determinate = false;
        progress_bar.progress = 0;
        function poll_for_results() {
          jQuery.ajax(json.response.uri, {method: "GET", dataType: "json",
                      xhrFields: {withCredentials: true}, headers: {Authorization: authHeader}, success: function(poll_json) {
            if ("failure" in poll_json) {
              jQuery("#progress_bar").hide();
              jQuery('#submit>i').html('build');
              reportErrors(poll_json.failure.errors);
            } else if ("progress" in poll_json) {
              progress_bar.determinate = poll_json.progress.percent > 0;
              progress_bar.progress = poll_json.progress.percent;
              setTimeout(poll_for_results, 1000);
            } else {
              jQuery("#progress_bar").hide();
              jQuery('#submit>i').html('build');
              draw_trees(poll_json);
            }
          }, error: function(jqXHR, textStatus) {
            jQuery("#progress_bar").hide();
            jQuery('#submit>i').html('build');
            if ("responseJSON" in jqXHR && "failure" in jqXHR.responseJSON)
              reportErrors(jqXHR.responseJSON.failure.errors);
            else
              alert("An error occurred" + ("responseText" in jqXHR ? ": " + jqXHR.responseText : "!"));
          }});
        }
        setTimeout(poll_for_results, 500);
      } else {
        jQuery('#submit>i').html('build');
        draw_trees(json);
      }
    }, error: function(jqXHR, textStatus) {
      jQuery('#submit>i').html('build');
      if ("responseJSON" in jqXHR && "failure" in jqXHR.responseJSON)
        reportErrors(jqXHR.responseJSON.failure.errors);
      else
        alert("An error occurred" + ("responseText" in jqXHR ? ": " + jqXHR.responseText : "!"));
    }});
  });
--></script>
  </body>
</html>
